/*
 * This file is part of ClanBomber;
 * you can get it at "http://www.nongnu.org/clanbomber".
 *
 * Copyright (C) 1999-2004, 2007 Andreas Hundt, Denis Oliver Kropp
 * Copyright (C) 2009 Rene Lopez <rsl@members.fsf.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef Debug_h
#define Debug_h

#include "GameObject.h"

class Debug : public GameObject
{
public:
	Debug( int _x, int _y, ClanBomberApplication *_app );
	~Debug();

	virtual void show();
	virtual void act();
	virtual void fall() {}; // does not fall ;-)
	
	int current_map;

	ObjectType get_type() const
	{
		return DEBUG;
	}

protected:
	
	bool key_F2;
	bool key_F3;
	bool key_divide;
	bool key_multiply;
};

#endif


